<?php
namespace Vitrium\Drm\HttpClient;

class HttpResponse {
    // Private fields. These are readonly and need to be initialized in the contructor call.
    private $code;
    private $headers;
    private $body;

    /**
    * Initialize response.
    *
    * @param int    $code    Response code.
    * @param array  $headers Response headers.
    * @param string $body    Response body.
    */
    public function __construct($code = 0, $headers = [], $body = '') {
        $this->code    = $code;
        $this->headers = $headers;
        $this->body    = $body;
    }

    // Property getters
    public function getCode() {
        return $this->code;
    }
    public function getHeaders() {
        return $this->headers;
    }
    public function getBody() {
        return $this->body;
    }
}
