<?php
namespace Vitrium\Drm\VitriumClasses;

class Folder implements \JsonSerializable {
    private $id;   // GUID folder ID
    private $externalKey;   // External key; can be used to associate with a third-party folder ID
    private $name;          // Folder name
    private $parentFolderId; // Parent folder GUID ID
    private $hasSubFolder;  // True if folder contains at least one subfolder
    private $customField;   // Custom field string

    // Property getters/setters
    public function getId() {
        return $this->id;
    }
    public function getExternalKey() {
        return $this->externalKey;
    }
    public function getName() {
        return $this->name;
    }
    public function getParentFolderId() {
        return $this->parentId;
    }
    public function getHasSubFolder() {
        return $this->hasSubFolder;
    }
    public function getCustomField() {
        return $this->customField;
    }
    public function setId($id) {
        $this->id = $id;
    }
    public function setExternalKey($externalKey) {
        $this->externalKey = $externalKey;
    }
    public function setName($name) {
        $this->name = $name;
    }
    public function setParentFolderId($parentId) {
        $this->parentId = $parentId;
    }
    public function setHasSubfolder($hasSubFolder) {
        $this->hasSubFolder = $hasSubFolder;
    }
    public function setCustomField($customField) {
        $this->customField = $customField;
    }

    /**
    * Create an instance of the Folder class.
    *
    * @param StdClass $object Optional object as retrieved from a Vitrium API call.
    */
    public function __construct($object = null) {
        $this->setId((isset($object) && is_object($object) && property_exists($object, 'Id')) ? $object->Id : '');
        $this->setName((isset($object) && is_object($object) && property_exists($object, 'Name')) ? $object->Name : '');
        $this->setParentFolderId((isset($object) && is_object($object) && property_exists($object, 'ParentFolderId')) ? $object->ParentFolderId : '');
        $this->setHasSubFolder(isset($object) && is_object($object) && property_exists($object, 'HasSubFolder') && $object->HasSubFolder);
        $this->setExternalKey((isset($object) && is_object($object) && property_exists($object, 'ExternalKey')) ? $object->ExternalKey : '');
        $this->setCustomField((isset($object) && is_object($object) && property_exists($object, 'CustomField')) ? $object->Id : '');
    }

    public function jsonSerialize() {
        return [
            'Id' => $this->getId(),
            'ExternalKey' => $this->getExternalKey(),
            'Name' => $this->getName(),
            'ParentFolderId' => $this->getParentFolderId(),
            'HasSubFolder' => $this->getHasSubFolder(),
            'CustomField' => $this->getCustomField()
        ];
    }
}
