<?php
namespace Vitrium\Drm\VitriumClasses;

// Class encapsulating GUID keys needed to communicate with Vitrium API
class VitriumApiKeys {
    private $sessionKey;   // Session key GUID
    private $accountKey;   // Account key GUID

    public function __construct($sessionKey, $accountKey) {
        $this->sessionKey = $sessionKey;
        $this->accountKey = $accountKey;
    }

    public function getSessionKey() {
        return $this->sessionKey;
    }
    public function getAccountKey() {
        return $this->accountKey;
    }

    // Returns a string containing Vitrium key information suitable for logging
    public function LogFormat() {
        return 'Session key = ' . (!isset($this->sessionKey) ? 'not set' : (empty($this->sessionKey) ? 'empty' : $this->sessionKey)) 
            . '; Account key = ' . (!isset($this->accountKey) ? 'not set' : (empty($this->accountKey) ? 'empty' : $this->accountKey)); 
    }

    // Returns true if both keys are set and not empty
    public function AreKeysSet() {
        return isset($this->sessionKey) && isset($this->accountKey) && !empty($this->sessionKey) && !empty($this->accountKey);
    }
}

